package com.kingdee.shr.compensation.app;

// Ҫ
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.compensation.util.CmpStrUtil;
import com.kingdee.util.DateTimeUtils;
import java.math.BigDecimal;
import java.sql.SQLException;
import java.text.ParseException;
import java.time.LocalDate;
import java.time.Period;
import java.util.Calendar;
import java.util.Date;
import java.util.HashSet;
import org.apache.log4j.Logger;

public class RetMoneyFacadeControllerBean extends AbstractRetMoneyFacadeControllerBean {
    // ־¼
    private static Logger logger = Logger.getLogger("com.kingdee.shr.compensation.app.RetMoneyFacadeControllerBean");

    // 캯
    public RetMoneyFacadeControllerBean() {
    }

    // д_retMoneyڻн
    protected void _retMoney(Context ctx) throws BOSException, EASBizException {
        // SQLѯ䣬ڻȡнʵ¼
        String sql = "/*dialect*/ SELECT FMONEY ,FID ,FPERSONID ,FCMPITEMID,FEFFECTDAY ,FLEFFECTDAY,CFTraceability,CFRetroactiveDate,foldfixadjustsalaryid   FROM T_HR_SFixAdjustSalary where  sysdate between   FEFFECTDAY  and FLEFFECTDAY and CFTraceability='Yes'   and (CFIsRet is null or CFIsRet=0)";
        HashSet<String> list = new HashSet<>(); // ڴ洢нʵ¼ID
        logger.error("sql" + sql); // ¼SQLѯ䵽־
        IRowSet rs = DbUtil.executeQuery(ctx, sql); // ִSQLѯȡ

        try {
            BigDecimal money;
            // еÿһм¼
            for (; rs.next(); logger.error("end mainid ==============" + money)) {
                BigDecimal sumMoney = BigDecimal.ZERO; // ʼнܶΪ0
                money = rs.getBigDecimal("FMONEY"); // ȡǰ¼нʵ
                logger.error("statrt mainid ==============" + money); // ¼ǰнʵ־
                Date cfretroactivedate = rs.getDate("cfretroactivedate"); // ȡ
                logger.error("cfretroactivedate " + DateTimeUtils.format(cfretroactivedate)); // ¼ڵ־
                String personid = rs.getString("FPERSONID"); // ȡԱID
                logger.error("personid " + personid); // ¼ԱID־
                String cmpitemid = rs.getString("FCMPITEMID"); // ȡнʵĿID
                Date mainEffectday = rs.getDate("FEFFECTDAY"); // ȡнʵЧ
                Date mainLeffectday = rs.getDate("FLEFFECTDAY"); // ȡнʵʧЧ
                String mainleftdayYearMonth = DateTimeUtils.format(mainEffectday, "yyyy-MM"); // ʽЧΪ-¡
                logger.error("mainleftdayYearMonth " + mainleftdayYearMonth); // ¼Чڵġ-¡־
                String oldfixadjustsalaryid = rs.getString("foldfixadjustsalaryid"); // ȡɵнʵID
                String id = rs.getString("fid"); // ȡǰнʵ¼ID
                list.add(id); // ǰ¼IDӵļ¼ID

                // ӲѯSQL䣬ڻȡضԱнʵʷ¼
                String detialSql = "/*dialect*/ select FEFFECTDAY ,FLEFFECTDAY,FMONEY,fid from T_HR_SFixAdjustSalary where FCMPITEMID='" + cmpitemid + "' " + " and fid ='" + oldfixadjustsalaryid + "' and  FPERSONID='" + personid + "' " + "   and (CFIsRet is null or CFIsRet=0) order by FEFFECTDAY asc ";
                logger.error("detial sql " + detialSql); // ¼ӲѯSQL䵽־
                IRowSet dettaiRs = DbUtil.executeQuery(ctx, detialSql); // ִӲѯȡ

                // ӲѯΪҰ¼
                if (dettaiRs != null && dettaiRs.size() > 0) {
                    String detialid;
                    // Ӳѯеÿһм¼
                    while (dettaiRs.next()) {
                        detialid = dettaiRs.getString("fid"); // ȡӲѯ¼ID
                        logger.error("start detialid================================= " + dettaiRs.getString("fid")); // ¼Ӳѯ¼ID־
                        BigDecimal detailMony = dettaiRs.getBigDecimal("FMONEY"); // ȡӲѯ¼нʵ 10000
                        logger.error("dettaiRsretMoney " + detailMony); // ¼Ӳѯ¼нʵ־
                        BigDecimal retMoney = money.subtract(detailMony); // н
                        logger.error("retMoney " + retMoney); // ¼нʵ־ 2000
                        Date effectday = dettaiRs.getDate("FEFFECTDAY"); // ȡӲѯ¼Ч
                        Date leffectday = dettaiRs.getDate("FLEFFECTDAY"); // ȡӲѯ¼ʧЧ
                        logger.error("detial_effectday " + DateTimeUtils.format(effectday)); // ¼Ӳѯ¼Чڵ־
                        logger.error("detial_leffectday " + DateTimeUtils.format(leffectday)); // ¼Ӳѯ¼ʧЧڵ־
                        logger.error("detial_leffectday_before " + cfretroactivedate.before(effectday)); // ¼ǷЧ֮ǰ

                        // ʼ
                        HashSet<String> monthSet = null;
                        int months = 0;
                        String beginYearMonth;
                        String endYearMonth;
                        int detiailbeginday;
                        Date lastDate;
                        int days;
                        BigDecimal arrMoney;
                        long cntdays;

                        // Ч֮ǰ
                        if (cfretroactivedate.before(effectday)) {
                            beginYearMonth = DateTimeUtils.format(effectday, "yyyy-MM"); // ʽЧΪ-¡
                            logger.error("beginYearMonth" + beginYearMonth); // ¼Чڵġ-¡־
                            endYearMonth = DateTimeUtils.format(leffectday, "yyyy-MM"); // ʽʧЧΪ-¡
                            logger.error("endYearMonth" + endYearMonth); // ¼ʧЧڵġ-¡־
                            monthSet = getMonthBetweenDate(effectday, leffectday); // ȡЧںʧЧ֮·ݼ
                            logger.error("monthSet" + monthSet); // ¼·ݼϵ־
                            months = this.getAllMonth(effectday, leffectday); // ЧںʧЧ֮·
                            logger.error("detial_months " + months); // ¼·־
                            detiailbeginday = DateTimeUtils.getDay(effectday); // ȡЧڵ
                            logger.error("detiailbeginday " + detiailbeginday); // ¼Чڵ־
                            lastDate = this.getlengthOfMonth(effectday); // ȡЧ·ݵһ
                            if (detiailbeginday != 1) { // ЧڲǸµĵһ
                                days = DateTimeUtils.getDay(lastDate); // ȡһ
                                logger.error("detial_all_days " + days); // ¼һ־
                                arrMoney = retMoney.divide(new BigDecimal(days), 5).setScale(2); // нʵƽ
                                logger.error("detial_arrMoney " + arrMoney); // ¼ƽ־
                                cntdays = this.getDaysBetweenDates(effectday, (Date) (lastDate.after(leffectday) ? leffectday : lastDate)) + 1L; // ڵһ
                                logger.error("detial_cntdays " + cntdays); // ¼־
                                sumMoney = sumMoney.add(arrMoney.multiply(new BigDecimal(cntdays))); // нܶ
                                logger.error("detial_sumMoney " + sumMoney); // ¼нܶ־
                                monthSet.remove(beginYearMonth); // ƳЧڵġ-¡·
                            }

                            // Ч·ݵʧЧ·
                            if (mainleftdayYearMonth.equals(endYearMonth)) {
                                monthSet.remove(endYearMonth); // ƳʧЧڵġ-¡·
                            }
                        } else {
                            // ڲЧ֮ǰ
                            months = this.getAllMonth(cfretroactivedate, leffectday); // ںʧЧ֮·
                            beginYearMonth = DateTimeUtils.format(cfretroactivedate, "yyyy-MM"); // ʽΪ-¡
                            logger.error("beginYearMonth" + beginYearMonth); // ¼ڵġ-¡־
                            endYearMonth = DateTimeUtils.format(leffectday, "yyyy-MM"); // ʽʧЧΪ-¡
                            logger.error("endYearMonth" + endYearMonth); // ¼ʧЧڵġ-¡־
                            monthSet = getMonthBetweenDate(cfretroactivedate, leffectday); // ȡںʧЧ֮·ݼ
                            logger.error("monthSet" + monthSet); // ¼·ݼϵ־
                            logger.error("detial_months " + months); // ¼·־
                            detiailbeginday = DateTimeUtils.getDay(cfretroactivedate); // ȡڵ
                            logger.error("detiailbeginday " + detiailbeginday); // ¼ڵ־
                            lastDate = this.getlengthOfMonth(cfretroactivedate); // ȡ·ݵһ
                            if (detiailbeginday != 1) { // ڲǸµĵһ
                                days = DateTimeUtils.getDay(lastDate); // ȡһ
                                logger.error("detial_all_days " + days); // ¼һ־
                                arrMoney = retMoney.divide(new BigDecimal(days), BigDecimal.ROUND_HALF_DOWN).setScale(2); // нʵƽ
                                logger.error("arrMoney " + arrMoney); // ¼ƽ־
                                cntdays = this.getDaysBetweenDates(cfretroactivedate, (Date) (lastDate.after(leffectday) ? leffectday : lastDate)) + 1L; // ڵһ
                                logger.error("detial_cntdays " + cntdays); // ¼־
                                sumMoney = sumMoney.add(arrMoney.multiply(new BigDecimal(cntdays))); // нܶ
                                logger.error("detial_sumMoney " + sumMoney); // ¼нܶ־
                                monthSet.remove(endYearMonth); // ƳʧЧڵġ-¡·
                            }

                            // ·ݵʧЧ·
                            if (mainleftdayYearMonth.equals(endYearMonth)) {
                                monthSet.remove(endYearMonth); // ƳʧЧڵġ-¡·
                            }
                        }

                        logger.error("monthSet ret " + monthSet); // ¼ʣ·ݼϵ־
                        // ʣ·ݼϲΪ
                        if (monthSet.size() > 0) {
                            sumMoney = sumMoney.add(retMoney.multiply(new BigDecimal(monthSet.size()))); // нܶ
                        }

                        logger.error("sumMoney " + sumMoney); // ¼нܶ־
                        list.add(detialid); // Ӳѯ¼IDӵļ¼ID
                        logger.error("end detialid================================= " + dettaiRs.getString("fid")); // ¼Ӳѯ¼ID־
                    }
                } else {
                    logger.error("ûенʷ0"); // ¼ûенʷ
                    sumMoney = BigDecimal.ZERO; // ûнܶΪ0
                }

                // SQL䣬ڼǷضԱн֧¼
                String exiSql = "select * from CT_CUS_PersonPayForm where CFPersonID ='" + personid + "' and CFAdjustSalary='" + id + "' ";
                logger.error("exiSql sql " + exiSql); // ¼SQL䵽־
                IRowSet extRs = DbUtil.executeQuery(ctx, exiSql); // ִSQLѯȡ

                String insertSql;
                // ΪҰ¼
                if (extRs != null && extRs.size() > 0) {
                    // SQL䣬ڸԱн֧еĻн
                    insertSql = "update  CT_CUS_PersonPayForm set CFRetMoney=" + sumMoney.setScale(2, 5) + " where  CFAdjustSalary='" + id + "' ";
                    logger.error("updateSql " + insertSql); // ¼SQL䵽־
                    DbUtil.execute(ctx, insertSql); // ִSQL²
                } else {
                    // Ϊջ򲻰¼
                    // SQL䣬Աн֧вµĻнʼ¼
                    insertSql = " /*dialect*/ insert into CT_CUS_PersonPayForm(fid,CFPersonID,CFMonth,CFRetMoney,cfadjustsalary) values(newbosid('5FB9A7AC'),'" + personid + "',to_date('" + DateTimeUtils.format(mainEffectday) + "','yyyy-MM-dd')" + "," + sumMoney.setScale(2, 5) + ",'" + id + "')";
                    logger.error("insertSql " + insertSql); // ¼SQL䵽־
                    DbUtil.execute(ctx, insertSql); // ִSQL
                }
            }

            String idStr = CmpStrUtil.convertListToString(list.toArray()); // ļ¼IDתΪַ
            logger.error("insqlInstance idStr " + CmpStrUtil.convertListToString(list.toArray())); // ¼ļ¼IDַ־
            // SQL䣬ڸнʵеĻݱ
            String updateAdjustSalarySql = "update T_HR_SFixAdjustSalary set cfisret=1 where fid in ( " + idStr + ") ";
            logger.error("updateAdjustSalarySql" + updateAdjustSalarySql); // ¼SQL䵽־
            DbUtil.execute(ctx, updateAdjustSalarySql); // ִSQL²
        } catch (SQLException var32) {
            var32.printStackTrace(); // ӡSQL쳣ջϢ
            throw new BOSException(""); // ׳ԶBOSException쳣
        } catch (ParseException var33) {
            var33.printStackTrace(); // ӡڽ쳣ջϢ
            throw new BOSException(""); // ׳ԶBOSException쳣
        }
    }

    // ȡضݺ·ݵ
    public int getALlDays(int year, int month) {
        Calendar calendar = Calendar.getInstance();
        calendar.set(year, month, 1);
        int daysInMonth = calendar.getActualMaximum(Calendar.DAY_OF_MONTH);
        return daysInMonth;
    }

    // ֮·
    public int getAllMonth(Date beginDate, Date endDate) {
        LocalDate startDatetmp = LocalDate.of(DateTimeUtils.getYear(beginDate), DateTimeUtils.getMonth(beginDate), DateTimeUtils.getDay(beginDate));
        LocalDate endDatetmp = LocalDate.of(DateTimeUtils.getYear(endDate), DateTimeUtils.getMonth(endDate), DateTimeUtils.getDay(endDate));
        logger.error("startDatetmp" + startDatetmp);
        logger.error("endDatetmp" + endDatetmp);
        Period period = Period.between(startDatetmp, endDatetmp);
        logger.error("period" + period);
        int months = period.getMonths();
        logger.error("months" + months);
        return months;
    }

    // ȡض·ݵһ
    public Date getlengthOfMonth(Date date) throws ParseException {
        logger.error("getlengthOfMonthdate" + date);
        LocalDate currentDate = LocalDate.of(DateTimeUtils.getYear(date), DateTimeUtils.getMonth(date), DateTimeUtils.getDay(date));
        logger.error("getlengthOfMonthdate" + currentDate);
        int lastDay = currentDate.lengthOfMonth();
        logger.error("getlengthOfMonthlastDay" + lastDay);
        String tempDate = DateTimeUtils.getYear(date) + "-" + DateTimeUtils.getMonth(date) + "-" + lastDay;
        logger.error("getlengthOfMonthtempDate" + tempDate);
        return DateTimeUtils.parseDate(tempDate);
    }

    // ֮
    public long getDaysBetweenDates(Date start, Date end) {
        Calendar cal = Calendar.getInstance();
        cal.setTime(start);
        long startTime = cal.getTimeInMillis();
        cal.setTime(end);
        long endTime = cal.getTimeInMillis();
        long diff = Math.abs(endTime - startTime);
        return diff / 86400000L;
    }

    // ȡ֮·ݼ
    public static HashSet<String> getMonthBetweenDate(Date startTime, Date endTime) {
        HashSet<String> list = new HashSet<>();

        // ֮·
        for (Calendar calendar = Calendar.getInstance(); startTime.getTime() <= endTime.getTime(); startTime = calendar.getTime()) {
            logger.error("getMonthBetweenDatetempDate" + DateTimeUtils.format(startTime, "yyyy-MM"));
            list.add(DateTimeUtils.format(startTime, "yyyy-MM"));
            calendar.setTime(startTime);
            calendar.add(Calendar.MONTH, 1);
        }

        return list;
    }
}
